/***************************************************************************/
/*                                                                         */
/*   astro.h      :  u JPL DEt@CpɂVvZ̃wb_t@C   */
/*      Ver. 2.0   2017/08/17          By   takesako@mrj.biglobe.ne.jp     */
/*                                           (c)1999 Shinobu Takesako      */
/***************************************************************************/
/*   1999/06/29 aʒuvZǉɔǉ                                 */
/*   1999/07/01 PʒuvZǉɔǉ                                 */
/*   2015/03/16 Nutation_PrecessionύX                                  */
/*   2016/10/10 eC												   */
/*   2017/08/17 Nutation֌W֐ɕύXBϐ̈nradian */
/***************************************************************************/


#define pai (3.1415926535897932/180.0)
#define pi2 (3.1415926535897932*2.0)
#define HToR (3.1415926535897932 / 12)
#define RToH (12 / 3.1415926535897932)

//#define SToR (pai/ 3600)

typedef struct tagPosition {
     double lam,  /* o   */
            bet,  /*    */
            ss,   /* a */
            x,    /* nSW */
            y,    /* nSW */
            z,    /* nSW */
			d,    /* nƂ̋ */
            ds,   /* zƒn̋ */
			r,    /* nƂ̋ */
            br,   /* x  */
            ra,   /* Ԍo  */
            dec,  /* Ԉ  */
			elong,/* ȃz̗p */
			phase,/* z|a|n̈ʑp */
			lamp, // o(␳) 2016/09/01ǉ
            betp, // (␳) 2016/09/01ǉ
            rap,  // Ԍo(␳) 2016/09/01ǉ
            decp, // Ԉ(␳) 2016/09/01ǉ
            ssp,  // a(␳) 2016/09/01ǉ
            brp,   // x  
			az,   // azimath angle(␳) 2016/09/01ǉ
            el,   // elevation angle(␳) 2016/09/01ǉ
            azs,  // azimath angle of sun(␳) 2016/09/01ǉ
            els,  // elevation angle of sun(␳) 2016/09/01ǉ
            ph,  // elevation angle of sun(␳) 2016/09/01ǉ
			lams,  // zo  
            bets,  // z  
             ras,   // zԌo 
            decs,  // zԈ  
			rr,// f̓SW	// 2017/08/08 add
			dd,// f̒nSW	// 2017/08/08 add
			pa,//wʑpxf猩đzƒnފp// 2017/08/08 add
			srr,// z̒nSW	// 2017/08/08 add
            Ebx,    //Barycentric Earth position // 2017/08/15 add
			Eby,    //Barycentric Earth position // 2017/08/15 add    
            Ebz,    //Barycentric Earth position // 2017/08/15 add    
            Ebvx,    //Barycentric Earth speed // 2017/08/15 add   
            Ebvy,    //Barycentric Earth speed // 2017/08/15 add      
            Ebvz,    //Barycentric Earth speed // 2017/08/15 add      
            Sbx,    //Barycentric Earth position // 2017/08/15 add    
            Sby,    //Barycentric Earth position // 2017/08/15 add    
            Sbz;    //Barycentric Earth position // 2017/08/15 add  

} Position;

// ϑn֘Ap[^p\̃^O 2016/08/31
typedef struct tagTlocation {
	double fai,lam;
	double psinfd,pcosfd;     
     } Tlocation;

typedef struct tagMatrix_3{
	double max[3][3];
} Matrix_3;


typedef struct tagMatrix_1{
	double max[3];
} Matrix_1;

/* common.c */
double JD(double year,double month,double day,double hour,int LST,double longitude);
void   Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude);
double LST( double jd, double longitude);
double SiderealTime(double jd);
double T_2000 (double jd);
double Obl0_2000(double jd);
double Obl_2000(double jd);
double OblNu_2000(double jd,double *dF,double *dE); // with Nutation

void   LamToRa(double jd,double Lam,double Bet,double *Ra,double *Dec);
void   RaToLam(double jd,double RA,double DEC,double *Lam,double *Bet);
void   Az_El(double jd,double Ra, double Dec, double latitude,double longitude,  double *Az, double *El );
void   Az_El2(double jd,double Ra, double Dec, double latitude,double longitude,  double *Az, double *El );
void   DateToYMD(double Date,double *Year,double *Month,double *Day);
void   DateToYMDH(double Date,double *year,double *month,double *day,double *hour);// 2016/09/08
double HMSToHour(double HMS);
double HMSToDeg(double HMS);// 1999/07/01 added
double DMSToDeg(double DMS);
double DegToHMS(double D);
double HourToHMS(double D);// 2016/09/08
double DegToDMS(double D);
double Digit3( double x);
double Digit2( double x);
void   Observer(double latitude, double longitude, double H,Tlocation *Obs);
double fmod_deg(double deg);
double fmod_rad(double deg);
void   Precession (double jd, double Year0, double RA0,double DEC0,double V1,double V2,double *RA,double *DEC);
void   Point(double jd, double a, double b, double c, double d, double *RA, double *DEC,int type);
void   Aberration(double jd, double Obl, double RA, double DEC,double *dRA,double *dDEC);// 2017/08/09 add
void   Star_posi_ALG(double jd, double RA0, double DEC0, double V1, double V2, double *RA, double *DEC,int type);// 2017/08/17 add
void   Star_posi_ALM(FILE *fp_Bin, int DE, double jd, double RA0, double DEC0, double ura, double udec, double Pi, double v, double *Ra, double *Dec);// 2017/08/17 add
void   RiseSet(FILE *fp_Bin,int DE,double jd, int Planet,int LST, Tlocation Obs,double *rise ,double *set);// 2017/08/17 add

/* Nutation.c */
void Nutation(double jd,double *dF, double *dE);// 2017/08/09 add
void Nutation_delta(double jd, double Obl, double dF, double dE, double RA, double DEC, double *dRA, double *dDEC);// 2017/08/09 add
void Nutation_Precession_Matrix (double jd,Matrix_3 *Pr,double Obl,double dE0, double dF0);// 2017/08/10 mod

/* Matrix.c */
void Sum_Matrix_3(Matrix_3 abc,Matrix_3 def,Matrix_3 *ghi);
void Multi_Matrix_3(Matrix_3 abc,Matrix_3 def,Matrix_3 *ghi);
void Sub_Matrix_3(Matrix_3 abc,Matrix_3 def,Matrix_3 *ghi);
void Multi_Const_Matrix_3(Matrix_3 abc,double a,Matrix_3 *ghi);
void Sum_Matrix_1(Matrix_1 ab,Matrix_1 de,Matrix_1 *gh);
void Multi_Matrix_1(Matrix_3 abc,Matrix_1 de,Matrix_1 *gh);
void Sub_Matrix_1(Matrix_1 ab,Matrix_1 de,Matrix_1 *gh);
void Multi_Const_Matrix_1(Matrix_1 ab,double a,Matrix_1 *gh);
void Eql_Matrix_1(Matrix_1 ab, Matrix_1 *gh);
void Scalar (Matrix_1 ab, double *a);
void Scalar_Dot (Matrix_1 ab,Matrix_1 de, double *a);
void Matrix_R1(Matrix_3 abc,double a, Matrix_3 *ghi);
void Matrix_R2(Matrix_3 abc,double a, Matrix_3 *ghi);
void Matrix_R3(Matrix_3 abc,double a, Matrix_3 *ghi);

void CordToMatrix_1( double RA , double DEC,Matrix_1 *gh);
void MatrixToCord_Matrix_1( Matrix_1 gh, double *RA , double *DEC);

/*jpl_eph.c*/
void   error_f(int i,char *msg);
double *dvector(int nl,int nh);
void   free_dvector(double *v,int nl);
char   **Cmatrix(int nrl, int nrh, int ncl, int nch);
void   free_Cmatrix(char **m, int nrl, int ncl);
void   GO2POS(FILE *fp,int nr);
FILE   *INITIAL(int DE);
void   PRINTOUT(void);
double Dint(double x);
int    SPLIT(double tt,double *fr);
double Dmod(double x,double y);
int    INTERP(double *buf,double *t,int ncf,int ncm,int na,int fl,double *pv);
int    STATE(FILE *fp_Bin,double *jed,int *list,double *pv,double *nut);
int    PLEPH0(FILE *fp_Bin,int n,double jd,int targ,int cent,double *rrd,
int    *inside,double *jd2);
int    PLEPH(FILE *fp_Bin,double jd,int targ,int cent,double *rrd,int *inside);
int    DPLEPH(FILE *fp_Bin,double *jd2,int targ,int cent,double *rrd);
void   Ephemerides(FILE *fp_Bin,int DE, double jd,int Planet,Position *Eph);
void   Ephemerides2(FILE *fp_Bin,int DE, double jd,int Planet,Position *Eph, Tlocation Obs);

//delta.c
double DeltaT(double t);

//star
void Star_posi_Matrix(double jd, double RA0, double DEC0, double V1, double V2, double *RA, double *DEC,int type);
void Precession_Matrix (double jd,Matrix_3 *Pr);
void Nutation_Matrix (double jd,Matrix_3 *Pr,double Obl,double dE0, double dF0);
