
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <conio.h>
#include "astro.h"
#include "Hip1997v22.h"


//***************************************************
//                 PLANET NUMBER                         
//                 1 = MERCURY         8 = NEPTUNE       
//                 2 = VENUS           9 = PLUTO         
//                (3 = EARTH)         10 = MOON          
//                 4 = MARS           11 = SUN           
//                 5 = JUPITER                           
//                 6 = SATURN                            
//                 7 = URANUS                            
//    "3" is not supported in this routine.
//***************************************************

 
 struct Location {
  double lon;
  double lat;
  double ht;
  char   *name ;
  };


static struct Location  Loctable[]={
{  0.00 , 0.00 ,0.00 ,"Center"},//0
{139.70 ,35.60 ,0.00 ,"`(V)"},//1
{139.57 ,35.32 ,0.00 ,"q"},//2
{135.80 ,34.50 ,0.00 ,""},//3
{135.80 ,34.70 ,0.00 ,"ޗ(鋞)"},//4
{135.75 ,35.00 ,0.00 ,"s"},//5
{135.70 ,34.90 ,0.00 ,""},//6
{135.50 ,34.50 ,0.00 ,"ޗǖ~n"},//7
{135.00 ,34.65 ,0.00 ,""},//8
{133.70 ,34.50 ,0.00 ,""},//9
{129.20 ,35.80 ,0.00 ,"cB(Vs)"},//10
{126.90 ,36.30 ,0.00 ,"}](Sϓs)"},//11
{125.80 ,39.00 ,0.00 ,"(s)"},//12
{118.78 ,32.03 ,0.00 ,"싞(Nanjing) "},//13
{117.00 ,35.60 ,0.00 ,"ȕ(Qifu)"},//14
{116.42 ,39.92 ,0.00 ,"k(Beijing) "},//15
{112.40 ,34.80 ,0.00 ,"z(Luoyang) "},//16
{108.90 ,34.30 ,0.00 ,"(Xi'an) "},//17
{105.80 ,21.02 ,0.00 ,"nmC"},//18
{ 46.20 ,31.00 ,0.00 ,"E"},//19
{ 44.50 ,32.50 ,0.00 ,"or"},//20
{ 44.30 ,33.50 ,0.00 ,"oO_bh"},//21
{ 43.20 ,36.50 ,0.00 ,"jlx"},//22
{ 35.78 ,35.62 ,0.00 ,"EKbg"},//23
{ 35.20 ,31.80 ,0.00 ,"GT"},//24
{ 32.60 ,25.70 ,0.00 ,"e|x"},//25
{ 31.50 ,29.90 ,0.00 ,"tBX(JC)"},//26
{ 30.00 ,31.30 ,0.00 ,"ALThA"},//27
{ 26.40 ,40.20 ,0.00 ,"wX|g"},//28
{ 23.70 ,38.00 ,0.00 ,"Ael"},//29
{ 15.20 ,37.10 ,0.00 ,"VNT"},//30
{ 15.00 ,38.00 ,0.00 ,"VV[C"},//31
{ 12.50 ,41.90 ,0.00 ,"|}"},//32
{ 10.30 ,36.80 ,0.00 ,"J^S"},//33
{  2.45 ,48.97 ,0.00 ,"p"},//34
{ -2.90 ,53.40 ,0.00 ,"ov["},//35
{133.70 ,34.50 ,0.00 ,""},//36
{  1.08 ,51.28 ,0.00 ,"J^x["},//37
{ 43.77 ,11.26 ,0.00 ,"tBcF"},//38

};


void main_star(void)
{
	double jd, RA0, DEC0, ura, udec, Pi, v,  Ra, Dec,V1,V2;
	int DE;
	FILE *fp_Bin;

	DE=405;
	fp_Bin=INITIAL(DE);

//	Astronomical Algorithms( 2nd)̕@ɂvZ
	printf("Astronomical Algorithms( 2nd)̕@ɂvZ\n");
	jd=JD(2028,11,13,19.0, 0,0.0);
	printf("DE=%4d  jd=%12.2f \n",DE,jd);
	printf("\n");
	
	RA0=( 2.0+44.0/60.0+11.986/3600.0)*15.0;// HR 799 13Per
	DEC0=(49.0+13.0/60.0+(42.48)/3600.0);
	printf("  RA0=%15.8f DEC0=%15.8f\n",HourToHMS(RA0/15),DegToDMS(DEC0));
	V1  = 0.03425;// s (sky2000type)
	V2  =-0.0895 ;// "
	Star_posi_ALG( jd, RA0, DEC0, V1, V2, &Ra, &Dec,1);
	printf("  RA =%15.8f DEC =%15.8f\n",HourToHMS(Ra/15),DegToDMS(Dec));
	printf("\n");

//	Astronomical Almanac̕@ɂvZ
	printf("Astronomical Almanac̕@ɂvZ\n");
	jd=JD(2028,11,13,19.0, 0,0.0);
	printf("DE=%4d  jd=%12.2f \n",DE,jd);
	printf("\n");
	
	RA0=( 2.0+44.0/60.0+11.986/3600.0)*15.0;
	DEC0=(49.0+13.0/60.0+(42.48)/3600.0);
	printf("  RA0=%15.8f DEC0=%15.8f\n",HourToHMS(RA0/15),DegToDMS(DEC0));
	V1  = 0.03425;// s (sky2000type)
	V2  =-0.0895 ;// " 
	ura =V1*15.0*1000.0*cos(DEC0*pai);//s->mas(milliarcseconds)
	udec=V2     *1000.0;//"->mas
	Pi  =  0.0;
	v   =  0.0;
	Star_posi_ALM(fp_Bin,DE, jd, RA0, DEC0, ura, udec, Pi, v, &Ra, &Dec);
	printf("  RA =%15.8f DEC =%15.8f\n",HourToHMS(Ra/15),DegToDMS(Dec));
	printf("\n");

/*
//	Astronomical Almanac 2014 B73-B74̌vZ
	jd=JD(2014, 1, 1, 0.0, 0,0.0);
	RA0=( 14.0+39.0/60.0+36.4958/3600.0)*15.0;
	DEC0=-(60.0+50.0/60.0+(2.309)/3600.0);
	ura=-3678.06;//mas/yr
	udec=482.87 ;//mas/yr
	Pi  =   0.742; (")
	v   = -21.6; km/s :Radial velocity
	printf("  RA0=%15.8f DEC0=%15.8f\n",HourToHMS(RA0/15),DegToDMS(DEC0));

	Star_posi_ALM(fp_Bin,DE, jd, RA0, DEC0, ura, udec, Pi, v, &Ra, &Dec);
	printf("  RA =%15.8f DEC =%15.8f\n",HourToHMS(Ra/15),DegToDMS(Dec));
	printf("\n");
//	vZ
//	RA(hh.mmss) =    14.40344188,   DEC(dd.mmss) =   -60.53131966
*/
	fclose(fp_Bin);

}




void main(void)
{
	double Date,year,month,day,hour,jd;
	double latitude,longitude,Hight;
	double a1,a2,a3,a4,a5,ra,dec,lam,bet,az,el,dt;
	double rise,set;
	int Planet,DE,m,mx,n,a6,type,k,LST;
 

	const char *Pl_Name[12] = {"       ", "Mercury", "Venus  ", "       ",
	"Mars   ", "Jupiter",       "Saturn ", "Uranus ", "Neptune", "Pluto  ",
	"Moon   ", "Sun    " };
	const char *Time[2] = {"LMT", "LST"};

	int Pl[7];
	FILE *fp_Bin;

	Position Eph;
	Tlocation Obs;

	struct Hip1997 *htable;		// \f[^̐ݒ
	struct Location *lctable;	// ϑnf[^̐ݒ
	htable=Hip1997table;		// \f[^̐ݒ
	lctable=Loctable;			// ϑnf[^̐ݒ
	


	DE=431;// JPL DEt@C̎w@jpl_eph.c"FILE *INITIAL(int DE)"֐ɂt@CƃfBNggpɍ킹ďC邱ƁB
	fp_Bin=INITIAL(DE);
	LST=0;// ʏLMT(nώ)ŌvZB(Longitude/15.0ŕ␳)@

//       YYYY.MMDDHHMMSS                  Ώې @ΏۓV̔ԍ@ϑnԍ@
//  ēwÓVwx
//	Date= 702.122812;		mx=1;Pl[0]=2;       			k= 3;//wÓVwxp.43  KIV  .1   	   at 
//	Date=1639.1204152500;	mx=2;Pl[0]=11;Pl[1]=2;			k=35;//wÓVwxp.45  KIV  .2 z/  at ov[
//	Date=1631.120706;		mx=2;Pl[0]=11;Pl[1]=2;			k=34;//wÓVwxp.46  KIV  .3 z/  at p
//	Date= -69.08041830;		mx=2;Pl[0]=10;Pl[1]=1;			k=17;//wÓVwxp.49  K V  .1 @/  at 
//	Date= 720.02292200;		mx=1;Pl[0]= 4;					k= 4;//wÓVwxp.53  KVI  .1 ΐ	   at ޗǕ鋞
//	Date=-356.05042100;		mx=2;Pl[0]=10;Pl[1]=4;			k=29;//wÓVwxp.54  KVI  .2 @/ΐ  at Ael(Aristotele)
//	Date=-356.05041921;		mx=2;Pl[0]=10;Pl[1]=4;			k=29;//wÓVwxp.54  KVI  .2 @/ΐ  at Ael(Aristotele)
//	Date=-209.03210500;		mx=1;Pl[0]= 4;					k=17;//wÓVwxp.55  KVI  .3 ΐ	   at  (͕s)
//	Date=-155.07271900;		mx=3;Pl[0]= 5;Pl[1]=2;Pl[2]=1;	k=17;//wÓVwxp.64  KVII .1 // at  
//	Date= 986.08010200;		mx=2;Pl[0]= 5;Pl[1]= 5531;		k= 5;//wÓVwxp.65  KVII .2 ؐ/Lib(HR553) at ޗǕ鋞 //PԍHRԍ
//	Date= 986.08010030;		mx=2;Pl[0]=10;Pl[1]= 1165;		k= 5;//wÓVwxp.65  KVII .2   /    at ޗǕ鋞 **ɂ͖**
//	Date=  -6.10271800;		mx=2;Pl[0]= 6;Pl[1]= 5; 		k=26;//wÓVwxp.74  KVIII.1 y/ؐ  at tBX
//	Date=  36.03312000;		mx=1;Pl[0]=10;					k=16;//wÓVwxp.82  KXI  .1 		   at z
//	Date=-600.01010000;		mx=1;Pl[0]=6134;				k= 0;//wÓVwxp.105 KXII .1 A^X(HR6134)		   
//	Date=1200.02191944;		mx=1;Pl[0]=2326;				k= 5;//wÓVwxp.109 KXII .2 Jm[vX(HR2326) at s	(C␳)	   
//	Date= 640.03042000;		mx=2;Pl[0]=10;Pl[1]= 1457;		k= 3;//wÓVwxp.114 KXIII.1 /Afo  at 
//	Date=-356.05041900;		mx=2;Pl[0]=10;Pl[1]=4;			k=29;//wÓVwxp.116 KXIII.2 @/ΐ  at Ael
//	Date= 679.08100400;		mx=2;Pl[0]=10;Pl[1]=2;			k=10;//wÓVwxp.116 KXIII.3 @/  at cB
//	Date= -69.08041830;		mx=2;Pl[0]=10;Pl[1]=1;			k=17;//wÓVwxp.118 KXIII.4 @/  at 
//	Date=-282.01292000;		mx=2;Pl[0]=10;Pl[1]= 1165;		k=27;//wÓVwxp.119 KXIII.5   /    at ALThA
//	Date=-708.07171500;		mx=2;Pl[0]=10;Pl[1]=11;			k=14;//wÓVwxp.124 KXIV .1   /z  at ȕ
//	Date=-600.09201600;		mx=2;Pl[0]=10;Pl[1]=11;			k=14;//wÓVwxp.125 KXIV .2   /z  at ȕ
//	Date=1183.11171125;		mx=2;Pl[0]=10;Pl[1]=11;			k=36;//wÓVwxp.126 KXIV .3   /z  at 
//	Date=-762.06151100;		mx=2;Pl[0]=10;Pl[1]=11;			k=22;//wÓVwxp.127 KXIV .4   /z  at jlx
//	Date=-309.08150800;		mx=2;Pl[0]=10;Pl[1]=11;			k=31;//wÓVwxp.129 KXIV .5   /z  at VV[C
//	Date= 158.07131900;		mx=2;Pl[0]=10;Pl[1]=11;			k= 7;//wÓVwxp.132 KXIV .6   /z  at ޗǖ~n
//	Date= 785.10222345;		mx=2;Pl[0]=10;Pl[1]=11;			k= 6;//wÓVwxp.132 KXV  .1   /z  at 
//	Date=-719.03082400;		mx=2;Pl[0]=10;Pl[1]=11;			k=20;//wÓVwxp.138 KXV  .2   /z  at or
//	Date=-2476.07150405;	mx=1;Pl[0]=2491;				k=26;//wÓVwxp.142 KXVI .1 VEX(HR2491) at tBX		   
//	Date=-2476.07150449;	mx=1;Pl[0]=11;					k=26;//wÓVwxp.143 KXVI .2 z at tBX		   
//	Date=1987.10111951;		mx=1;Pl[0]=10;					k= 1;//wÓVwxp.144 KXVI .3 		   at `(V)
//	Date=-205.08070400;		mx=6;Pl[0]=11;Pl[1]=1;Pl[2]=2;Pl[3]=4;Pl[4]=5;Pl[5]=6;	k=17;//wÓVwxp.148  KXVII .1 z/////y at  
//	Date=-522.10230530;		mx=5;Pl[0]=11;Pl[1]=2;Pl[2]=4;Pl[3]=5;Pl[4]=6;			k=21;//wÓVwxp.148  KXVII .2 z////y at oO_bh 
//	Date=1349.07120400;		mx=4;Pl[0]=11;Pl[1]=1;Pl[2]=2;Pl[3]=5;					k= 5;//wÓVwxp.150  KXVII .3 z///ؐ at s
//	Date=1349.07140400;		mx=5;Pl[0]=11;Pl[1]=10;Pl[2]=1;Pl[3]=2;Pl[4]=5;			k= 5;//wÓVwxp.151  KXVII .3 z////ؐ at s
//	Date= 182.12221800;		mx=4;Pl[0]=11;Pl[1]=5;Pl[2]=4;Pl[3]=2;					k=16;//wÓVwxp.152  KXVII .4 z///ؐ at z
//  ̑̎
//	Date= 681.11040218;		mx=2;Pl[0]=10;Pl[1]= 4;				k= 3;//w򒹎̓Vwxp.14				/ΐ				at 
//	Date=-336.12051800;		mx=2;Pl[0]= 5;Pl[1]=2134;			k=29;//wSky & Telescope 1992/06xp.676		ؐ/1Gem			at Ael(Aristotele)
//	Date=-271.10120430;		mx=2;Pl[0]= 2;Pl[1]=4689;			k=27;// ToomerwAlmagest(10.4)xp.477		/Vir(HR4689)	at ALThA
//	Date=-271.01160600;		mx=2;Pl[0]= 4;Pl[1]=5984;			k=27;// ToomerwAlmagest(10.9)xp.502		ΐ/Sco(HR5984)	at ALThA
//	Date=-240.09040400;		mx=2;Pl[0]= 5;Pl[1]=3461;			k=27;// ToomerwAlmagest(11.3)xp.522		ؐ/Scn(HR3461)	at ALThA
//	Date=1170.09122100;		mx=2;Pl[0]=4;Pl[1]= 5;				k= 37;//wSky & Telescope(1992)xp.207		ΐ/ؐ			at J^x[(Canterbury)
//	Date=1613.01282300;		mx=2;Pl[0]=5;Pl[1]= 8;				k= 38;//wV 2009N11xp.699		ؐ/C			at tBcF by KI

//   start_time=TIME;
//   while(start_time==TIME);
//   start_time++;
//   while(start_time==TIME) base++;


	Date=2016.12311800;		mx=7;Pl[0]=1;Pl[1]=2;Pl[2]=4;Pl[3]=5;Pl[4]=6;Pl[5]=11;Pl[6]=10;		k= 1; LST=1;//2017N̑A̗[Ɍf(/ΐ/O) at iLST ߌ6j

	longitude=	lctable[k].lon;
	latitude =	lctable[k].lat;
	Hight    =  lctable[k].ht;
	Observer( latitude, longitude, Hight,&Obs);//n̐ݒ

	DateToYMDH( Date, &year, &month, &day, &hour);
	jd=JD(year, month, day, hour, LST,longitude);// jd͐E(UT)
	dt=DeltaT(T_2000 ( jd));
 
	printf("\n DE-%3d Planetary Position on %5.0f/%2.0f/%2.0f: h.ms %2.4f[%s] : JD= %.6f t=%7.1fsec \n ܓx :%8.2f x ox :%8.2f x  ϑn: %s Site#;%2d \n",DE, year,month,day,HourToHMS(hour),Time[LST],jd,dt,latitude,longitude,lctable[k].name,k);
	printf("\n");
	printf("           o           ␳      a   nS   x   x   ʁ@ p@zx\n");
	printf(" Target     lam      bet      lamp      betp    ssp      dist.     Mg     El     Az     ELO   El_sun\n");

	for(m=0;m<=mx-1;m++){//ΏۓV̂̐[vB
	Eph.lam=0.0;Eph.bet=0.0;Eph.lamp=0.0;Eph.betp=0.0;Eph.ss=0.0;Eph.ssp=0.0;Eph.d=0.0;Eph.br=0.0;Eph.el=0.0;Eph.az=0.0;Eph.ph=0.0;Eph.els=0.0;

	if(Pl[m]<=11)
	{//zEEf̏ꍇ
	Planet=Pl[m];
	Ephemerides2( fp_Bin,DE,jd, Planet, &Eph,Obs);//  jd͐E(UT)
	printf  ("%9s%9.3f %7.3f  %9.3f %7.3f  %7.4f  %7.4f  %5.2f %6.1f %6.1f %7.1f  %5.1f\n",Pl_Name[Planet], Eph.lam/pai,Eph.bet/pai,Eph.lamp/pai,Eph.betp/pai,Eph.ssp/pai,Eph.d,Eph.br,Eph.el/pai,Eph.az/pai,Eph.ph/pai,Eph.els/pai);
	}//if(Pl[m]<=11)

	else
	{//fŖꍇ(Pl[]>10)HRԍōPXgB(HRԍ10Ԉȉ͎̐włȂ̂Œ)@*** ␳   ***
	n=0;
	while(1){
		if(htable[n].HR==Pl[m])break;//HRԍƓȂ烋[voB
		n++;
		};
	a1=htable[n].ra; a2=htable[n].dec; a3=htable[n].pmr; a4=htable[n].pmd; a5=htable[n].mg;a6=htable[n].HR;//\z񂩂f[^̓ǂݍ
	type=1;// 1Fsky2000J^O type̍΍̌vZ, 0:BSCJ^O type̍΍̌vZ
	Point( jd, a1, a2, a3, a4, &ra, &dec , type);	//΍̌vZ
	RaToLam( jd, ra*pai, dec*pai, &lam, &bet);				//o܂֕ϊ
	Az_El  ( jd, ra*pai, dec*pai, latitude, longitude, &el, &az );
	printf  ("%9s%9.3f %7.3f  %9.3f %7.3f                    %5.2f %6.1f %6.1f\n",htable[n].name, lam/pai, bet/pai,lam/pai,bet/pai, a5,az/pai,el/pai );
	}//else


	}//for(m=0;m<=mx-1;m++){
	printf("\n");

	//V̂̏ov̌vZ
	Planet=11;
	RiseSet(fp_Bin, DE, jd, Planet, LST, Obs,&rise , &set);
	printf(" %s Rise(h.mmss) : %8.4f  %s set(h.mmss) : %8.4f\n\n",Pl_Name[Planet],HourToHMS(rise),Pl_Name[Planet],HourToHMS(set));

fclose(fp_Bin);

}
